/* 
Teste 3 - Criar um ficheiro, ver a cache (verificar que M está a 1 dos blocos do ficheiro. Dormir 11 segundos, verificar que M está a 0. 

 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <myfs.h>



int main(int argc, char **argv)
{
   int fd, num;

   // mandatory to init the myfs layer
   my_init_lib();

   // create the empty file 'test.txt' in the root directory
   fd = my_open("/cache3.txt",O_CREATE);
   if (fd < 0) {
      printf("[test] unable to open file.\n");
      return -1;
   }

   // fill in a buffer with ascii chars
   char data[2*1024];
   for (int i = 0; i < sizeof(data); data[i]='a'+i%10, i++);

   // write the data to the file
   num = my_write(fd, data, sizeof(data));
   if (num < sizeof(data)) {
      printf("[test] error writing data to file.\n");
      return -1;
   }
   
   // close the file
   if (my_close(fd) < 0) {
      printf("[test] error closing file.\n");
      return -1;
   }

  // Dump server's cache of blocks 
  if(my_dumpcache()<0){
      printf("[test] error server's cache dumping.\n");
      return -1;
   }
      
   printf("\n[test] Please check on server terminal if:\n		- Bit M value of blocks 11,12,13 and 14 is 1.\n\n");  	

   puts("sleeping 11 seconds…");
   sleep(11);
   	
  // Dump server's cache of blocks 
  if(my_dumpcache()<0){
      printf("[test] error server's cache dumping.\n");
      return -1;
   }
      
   printf("\n[test] Please check on server terminal if:\n		- Bit M value of blocks 11,12,13 and 14 is 0.\n\n");  	
   	
   return 0;
}


